/[gentoo-x86]/sys-power/nut/nut-2.4.3.ebuild
Gentoo

Contents of /sys-power/nut/nut-2.4.3.ebuild

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.4 - (show annotations) (download)
Sat Feb 12 23:16:14 2011 UTC (9 years ago) by ssuominen
Branch: MAIN
CVS Tags: HEAD
Changes since 1.3: +1 -1 lines
FILE REMOVED
old

(Portage version: 2.2.0_alpha23/cvs/Linux x86_64)

1 # Copyright 1999-2010 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/sys-power/nut/nut-2.4.3.ebuild,v 1.3 2010/06/22 20:07:21 arfrever Exp $
4
5 EAPI="2"
6
7 inherit eutils fixheadtails autotools bash-completion
8
9 MY_P="${P/_/-}"
10
11 DESCRIPTION="Network-UPS Tools"
12 HOMEPAGE="http://www.networkupstools.org/"
13 # Nut mirrors are presently broken
14 SRC_URI="http://random.networkupstools.org/source/${PV%.*}/${MY_P}.tar.gz
15 http://www.networkupstools.org/source/${PV%.*}/${MY_P}.tar.gz"
16
17 S="${WORKDIR}/${MY_P}"
18
19 LICENSE="GPL-2"
20 SLOT="0"
21 KEYWORDS="~alpha ~amd64 ~ppc ~sparc ~x86 ~x86-fbsd"
22 IUSE="cgi snmp usb ssl hal xml"
23
24 RDEPEND="cgi? ( >=media-libs/gd-2[png] )
25 snmp? ( net-analyzer/net-snmp )
26 usb? ( =virtual/libusb-0* )
27 hal? ( >=sys-apps/hal-0.5.11 )
28 ssl? ( dev-libs/openssl )
29 xml? ( >=net-libs/neon-0.25.0 )
30 >=sys-fs/udev-114"
31 DEPEND="$RDEPEND
32 >=sys-apps/sed-4
33 >=sys-devel/autoconf-2.58
34 dev-util/pkgconfig"
35
36 # public files should be 644 root:root
37 NUT_PUBLIC_FILES="/etc/nut/{ups,upssched}.conf"
38 # private files should be 640 root:nut - readable by nut, writeable by root,
39 NUT_PRIVATE_FILES="/etc/nut/{upsd.conf,upsd.users,upsmon.conf}"
40 # public files should be 644 root:root, only installed if USE=cgi
41 NUT_CGI_FILES="/etc/nut/{{hosts,upsset}.conf,upsstats{,-single}.html}"
42
43 pkg_setup() {
44 enewgroup nut 84
45 enewuser nut 84 -1 /var/lib/nut nut,uucp
46 # As of udev-104, NUT must be in uucp and NOT in tty.
47 gpasswd -d nut tty 2>/dev/null
48 gpasswd -a nut uucp 2>/dev/null
49 use hal && gpasswd -a haldaemon nut 2>/dev/null
50 # in some cases on old systems it wasn't in the nut group either!
51 gpasswd -a nut nut 2>/dev/null
52 warningmsg ewarn
53 }
54
55 src_prepare() {
56 ht_fix_file configure.in
57
58 epatch "${FILESDIR}"/${PN}-2.4.1-no-libdummy.patch
59
60 sed -e "s:GD_LIBS.*=.*-L/usr/X11R6/lib \(.*\) -lXpm -lX11:GD_LIBS=\"\1:" \
61 -i configure.in || die "sed failed"
62
63 sed -e "s:52.nut-usbups.rules:70-nut-usbups.rules:" \
64 -i scripts/udev/Makefile.am || die "sed failed"
65
66 rm -f ltmain.sh m4/lt* m4/libtool.m4
67
68 WANT_AUTOCONF=2.5 eautoreconf || die "autoconf failed"
69 }
70
71 src_configure() {
72 local myconf
73
74 if [ -n "${NUT_DRIVERS}" ]; then
75 myconf="${myconf} --with-drivers=${NUT_DRIVERS// /,}"
76 fi
77
78 econf \
79 --with-user=nut \
80 --with-group=nut \
81 --with-drvpath=/lib/nut \
82 --sysconfdir=/etc/nut \
83 --with-logfacility=LOG_DAEMON \
84 --with-statepath=/var/lib/nut \
85 --with-htmlpath=/usr/share/nut/html \
86 --datarootdir=/usr/share/nut \
87 --datadir=/usr/share/nut \
88 --with-dev \
89 $(use_with xml neon) \
90 $(use_with hal) \
91 $(use_with ssl) \
92 $(use_with usb) \
93 $(use_with snmp) \
94 $(use_with cgi) \
95 $(use_with cgi cgipath /usr/share/nut/cgi) \
96 ${myconf} || die "econf failed"
97
98 }
99
100 src_install() {
101
102 emake DESTDIR="${D}" install || die "make install failed"
103
104 dodir /sbin
105 dosym /lib/nut/upsdrvctl /sbin/upsdrvctl
106 # This needs to exist for the scripts
107 dosym /lib/nut/upsdrvctl /usr/sbin/upsdrvctl
108
109 if use cgi; then
110 elog "CGI monitoring scripts are installed in /usr/share/nut/cgi."
111 elog "copy them to your web server's ScriptPath to activate (this is a"
112 elog "change from the old location)."
113 elog "If you use lighttpd, see lighttpd_nut.conf in the documentation."
114 fi
115
116 # this must be done after all of the install phases
117 for i in "${D}"/etc/nut/*.sample ; do
118 mv "${i}" "${i/.sample/}"
119 done
120
121 dodoc ChangeLog INSTALL MAINTAINERS NEWS README UPGRADING \
122 docs/{FAQ,*.txt} || die
123
124 newdoc lib/README README.lib || die
125
126 newdoc "${FILESDIR}"/lighttpd_nut.conf-2.2.0 lighttpd_nut.conf || die
127
128 docinto cables
129 dodoc docs/cables/* || die
130
131 newinitd "${FILESDIR}"/nut-2.2.2-init.d-upsd upsd \
132 || die "newinitd failed"
133 newinitd "${FILESDIR}"/nut-2.2.2-init.d-upsdrv upsdrv \
134 || die "newinitd failed"
135 newinitd "${FILESDIR}"/nut-2.2.2-init.d-upsmon upsmon \
136 || die "newinitd failed"
137 newinitd "${FILESDIR}"/nut.powerfail.initd nut.powerfail \
138 || die "newinitd failed"
139
140 # This sets up permissions for nut to access a UPS
141 insinto /etc/udev/rules.d/
142 newins scripts/udev/nut-usbups.rules 70-nut-usbups.rules
143
144 keepdir /var/lib/nut
145
146 einfo "Setting up permissions on files and directories"
147 fperms 0700 /var/lib/nut
148 fowners nut:nut /var/lib/nut
149
150 # Do not remove eval here, because the variables contain shell expansions.
151 eval fperms 0640 ${NUT_PRIVATE_FILES}
152 eval fowners root:nut ${NUT_PRIVATE_FILES}
153
154 # Do not remove eval here, because the variables contain shell expansions.
155 eval fperms 0644 ${NUT_PUBLIC_FILES}
156 eval fowners root:root ${NUT_PUBLIC_FILES}
157
158 # Do not remove eval here, because the variables contain shell expansions.
159 if use cgi; then
160 eval fperms 0644 ${NUT_CGI_FILES}
161 eval fowners root:root ${NUT_CGI_FILES}
162 fi
163
164 # this is installed for 2.4 and fbsd guys
165 if ! has_version sys-fs/udev; then
166 einfo "Installing non-udev hotplug support"
167 insinto /etc/hotplug/usb
168 insopts -m 755
169 doins scripts/hotplug/nut-usbups.hotplug
170 fi
171
172 if use hal; then
173 einfo "Installing HAL support"
174 insinto /usr/share/hal/fdi/information/20thirdparty/
175 doins scripts/hal/20-ups-nut-device.fdi
176 insinto /usr/libexec
177 insopts -m 755
178 doins drivers/hald-addon-*
179 rm "${D}"/lib/nut/hald-addon-*
180 fi
181
182 dobashcompletion "${S}"/scripts/misc/nut.bash_completion
183 }
184
185 pkg_postinst() {
186 # this is to ensure that everybody that installed old versions still has
187 # correct permissions
188
189 chown nut:nut "${ROOT}"/var/lib/nut 2>/dev/null
190 chmod 0700 "${ROOT}"/var/lib/nut 2>/dev/null
191
192 # Do not remove eval here, because the variables contain shell expansions.
193 eval chown root:nut "${ROOT}"${NUT_PRIVATE_FILES} 2>/dev/null
194 eval chmod 0640 "${ROOT}"${NUT_PRIVATE_FILES} 2>/dev/null
195
196 # Do not remove eval here, because the variables contain shell expansions.
197 eval chown root:root "${ROOT}"${NUT_PUBLIC_FILES} 2>/dev/null
198 eval chmod 0644 "${ROOT}"${NUT_PUBLIC_FILES} 2>/dev/null
199
200 # Do not remove eval here, because the variables contain shell expansions.
201 if use cgi; then
202 eval chown root:root "${ROOT}"${NUT_CGI_FILES} 2>/dev/null
203 eval chmod 0644 "${ROOT}"${NUT_CGI_FILES} 2>/dev/null
204 fi
205
206 warningmsg elog
207 }
208
209 warningmsg() {
210 msgfunc="$1"
211 [ -z "$msgfunc" ] && die "msgfunc not specified in call to warningmsg!"
212 ${msgfunc} "Please note that NUT now runs under the 'nut' user."
213 ${msgfunc} "NUT is in the uucp group for access to RS-232 UPS."
214 ${msgfunc} "However if you use a USB UPS you may need to look at the udev or"
215 ${msgfunc} "hotplug rules that are installed, and alter them suitably."
216 ${msgfunc} ''
217 ${msgfunc} "If you use hald, you may be able to skip the normal init scripts."
218 ${msgfunc} ''
219 ${msgfunc} "You are strongly advised to read the UPGRADING file provided by upstream."
220 ${msgfunc} ''
221 ${msgfunc} "Please note that upsdrv is NOT automatically started by upsd anymore."
222 ${msgfunc} "If you have multiple UPS units, you can use their NUT names to"
223 ${msgfunc} "have a service per UPS:"
224 ${msgfunc} "ln -s /etc/init.d/upsdrv /etc/init.d/upsdrv.\$UPSNAME"
225 ${msgfunc} ''
226 ${msgfunc} 'If you want apcupsd to power off your UPS when it'
227 ${msgfunc} 'shuts down your system in a power failure, you must'
228 ${msgfunc} 'add nut.powerfail to your shutdown runlevel:'
229 ${msgfunc} ''
230 ${msgfunc} 'rc-update add nut.powerfail shutdown'
231 ${msgfunc} ''
232
233 }

  ViewVC Help
Powered by ViewVC 1.1.20